Index: modules/gui/macosx/intf.h
===================================================================
--- modules/gui/macosx/intf.h	(revision 20826)
+++ modules/gui/macosx/intf.h	(working copy)
@@ -283,6 +283,9 @@
 
     bool b_small_window;
 
+    bool b_restore_size;
+    NSRect o_restore_rect;
+
     mtime_t i_end_scroll;
 
     NSSize o_size_with_playlist;
Index: modules/gui/macosx/intf.m
===================================================================
--- modules/gui/macosx/intf.m	(revision 20826)
+++ modules/gui/macosx/intf.m	(working copy)
@@ -465,6 +465,7 @@
     [self manageVolumeSlider];
     [o_window setDelegate: self];
     
+    b_restore_size = false;
     if( [o_window frame].size.height <= 200 )
     {
         b_small_window = YES;
@@ -1986,6 +1987,8 @@
     /*First, check if the playlist is visible*/
     if( o_rect.size.height <= 200 )
     {
+        o_restore_rect = o_rect;
+        b_restore_size = true;
         b_small_window = YES; /* we know we are small, make sure this is actually set (see case below) */
         /* make large */
         if ( o_size_with_playlist.height > 200 )
@@ -2007,10 +2010,20 @@
         o_rect.origin.x = [o_window frame].origin.x;
         o_rect.origin.y = [o_window frame].origin.y - o_rect.size.height +
                                                 [o_window minSize].height;
+
+        NSRect screenRect = [[o_window screen] visibleFrame];
+        if ( !NSContainsRect( screenRect, o_rect ) ) {
+            if ( NSMaxX(o_rect) > NSMaxX(screenRect) )
+                o_rect.origin.x = ( NSMaxX(screenRect) - o_rect.size.width );
+            if ( NSMinY(o_rect) < NSMinY(screenRect) )
+                o_rect.origin.y = ( NSMinY(screenRect) );
+        }
+
         [o_btn_playlist setState: YES];
     }
     else
     {
+        NSSize curSize = o_rect.size;
         /* make small */
         o_rect.size.height = [o_window minSize].height;
         o_rect.size.width = [o_window minSize].width;
@@ -2019,6 +2032,9 @@
         o_rect.origin.y = [o_window frame].origin.y +
             [o_window frame].size.height - [o_window minSize].height;
 
+        if ( b_restore_size ) 
+            o_rect = o_restore_rect;
+
         [o_playlist_view setAutoresizesSubviews: NO];
         [o_playlist_view removeFromSuperview];
         [o_btn_playlist setState: NO];
@@ -2062,6 +2078,11 @@
     return proposedFrameSize;
 }
 
+- (void)windowDidMove:(NSNotification *)notif
+{
+    b_restore_size = false;
+}
+
 - (void)windowDidResize:(NSNotification *)notif
 {
     if( [o_window frame].size.height > 200 && b_small_window )
